
	void clearBuffers()
	{
		// Declare area
		SDL_Rect dest;
		dest.x = 0; dest.y = 0; dest.w = 640; dest.h = 1;
		float color = 0;

		// Fade out the screen
		SDL_Rect fade;
		fade.x = 0; fade.y = 0; fade.w = 640; fade.h = 400;
		SDL_FillRect(surMainScreen, &fade, SDL_MapRGBA(surMainScreen->format, 0, 0, 0, 0));
		SDL_Flip(surMainScreen);


		// Clear the back buffer (x, y, width, height, r, g, b, surface);
		// This code is experimental, as it fills the background with a deep gree colour, or otherwise, specific to the level
		// The level check is not yet implemented
      for (dest.y = 0; dest.y < 400; dest.y++)
		{
			if (color < 100){color += 0.07;}
			SDL_FillRect(surBackBuffer, &dest, SDL_MapRGB(surBackBuffer->format, 5+((int)color/2), (13+(int)color), 0));
		}

		// Clear the collision layer
		int a, b;
		for (b = 0; b < 400; b++)
		{
			for (a = 0; a < 640; a++)
			{
				iCollisionLayer[b][a] = 0;
			}
		}
	}

	void fancyFadeToBlack()
	{
      // Declare area
		SDL_Rect dest;
		dest.x = 0; dest.y = 0; dest.w = 640; dest.h = 1;
		float color = 0;

		int y;

		for (y = 1; y < 639; y += 2)
		{
			dest.y = y;
			SDL_FillRect(surMainScreen, &dest, SDL_MapRGB(surMainScreen->format, 0, 0, 0));
			dest.y = 481-y;
			SDL_FillRect(surMainScreen, &dest, SDL_MapRGB(surMainScreen->format, 0, 0, 0));
			SDL_Flip(surMainScreen);
			SDL_Delay(2);
		}
	}

	void drawForeground()
	{
		int rows, cols, x, y; y = 0;
		SDL_Rect myrect; myrect.x = 0; myrect.y = 0;
		for (rows = 0; rows < 10; rows++)
		{
			x = 0;
      	for (cols = 0; cols < 16; cols++)
			{
         	myrect.x = x; myrect.y = y;

				switch (iAllForegrounds[iLevel][(iLevelMap[iLevel][iMapOffsetY][iMapOffsetX])][rows][cols])
				{
					case 1:
					SDL_BlitSurface(foregrounds[0], NULL, surMainScreen, &myrect);
					break;

					case 2:
					SDL_BlitSurface(foregrounds[1], NULL, surMainScreen, &myrect);
					break;

					case 3:
					SDL_BlitSurface(foregrounds[2], NULL, surMainScreen, &myrect);
					break;

					case 4:
					SDL_BlitSurface(foregrounds[3], NULL, surMainScreen, &myrect);
					break;

					// Water
					case 5:
					SDL_BlitSurface(foregrounds[4], NULL, surMainScreen, &myrect);
					break;
					case 6:
					SDL_BlitSurface(foregrounds[5], NULL, surMainScreen, &myrect);
					break;
					case 7:
					SDL_BlitSurface(foregrounds[6], NULL, surMainScreen, &myrect);
					break;
					case 8:
					SDL_BlitSurface(foregrounds[7], NULL, surMainScreen, &myrect);
					break;
					case 9:
					SDL_BlitSurface(foregrounds[8], NULL, surMainScreen, &myrect);
					break;
					case 10:
					SDL_BlitSurface(foregrounds[9], NULL, surMainScreen, &myrect);
					break;

				}
				x += 40;
			}
			y += 40;
		}
	}

	void drawBackgroundZone(int type, int x, int y)
	{
		int startX, startY, endX, endY, a, b;
		int* sX = &startX;
		int* sY = &startY;
		int* eX = &endX;
		int* eY = &endY;
		int invert = 0;
		int* invertValue = &invert;

		// Full tile zone
		if (type == 1)
		{
			*sX = x;
			*sY = y;
			*eX = x+40;
			*eY = y+40;
		}

		// Half bottom tile zone
		if (type == 10)
		{
			*sX = x;
			*sY = y+20;
			*eX = x+40;
			*eY = y+40;
		}

		// Half top tile zone
		if (type == 5)
		{
			*sX = x;
			*sY = y;
			*eX = x+40;
			*eY = y+20;
		}

		// Top left corner zone
		if (type == 8)
		{
			*sX = x;
			*sY = y;
			*eX = x+20;
			*eY = y+20;
		}

		// Top right corner zone
		if (type == 9)
		{
			*sX = x+20;
			*sY = y;
			*eX = x+40;
			*eY = y+20;
		}

		// Bottom left corner zone
		if (type == 6)
		{
			*sX = x;
			*sY = y+20;
			*eX = x+20;
			*eY = y+40;
		}

		// Bottom right corner zone
		if (type == 7)
		{
			*sX = x+20;
			*sY = y+20;
			*eX = x+40;
			*eY = y+40;
		}

		// Left half
		if (type == 2)
		{
			*sX = x;
			*sY = y;
			*eX = x+20;
			*eY = y+40;
		}

		// Right half
		if (type == 3)
		{
			*sX = x+20;
			*sY = y;
			*eX = x+40;
			*eY = y+40;
		}

		//   *
		//   * - formed zone
		// ***
		if (type == 12)
		{
			*sX = x;
			*sY = y;
			*eX = x+19;
			*eY = y+19;
			*invertValue = 1;
		}

		// *
		// *   - formed zone
		// ***
		if (type == 11)
		{
			*sX = x+21;
			*sY = y;
			*eX = x+40;
			*eY = y+19;
			*invertValue = 1;
		}

		// ***
		// *   - formed zone
		// *
		if (type == 13)
		{
			*sX = x;
			*sY = y;
			*eX = x+19;
			*eY = y+19;
			*invertValue = 1;
		}

		// ***
		//   * - formed zone
		//   *
		if (type == 14)
		{
			*sX = x+21;
			*sY = y;
			*eX = x+40;
			*eY = y+19;
			*invertValue = 1;
		}

      // Tile sea

		if (type == 16)
		{
			*sX = x;
			*sY = y+20;
			*eX = x+40;
			*eY = y+40;
		}
		if (type == 17)
		{
			*sX = x+21;
			*sY = y;
			*eX = x+40;
			*eY = y+19;
			*invertValue = 1;
		}
		if (type == 18)
		{
			*sX = x;
			*sY = y;
			*eX = x+19;
			*eY = y+19;
			*invertValue = 1;
		}

		// special tiles are not drawn zones for usually


		/* Draw the zone */
		if (*invertValue)
		{
			for (b = y; b < y+40; b++)
			{
				for (a = x; a < x+40; a++)
				{
					if (a >= startX & a <= endX & b >= startY & b <= endY)
					{
						iCollisionLayer[b][a] = 0;
					}
					else
					{
						iCollisionLayer[b][a] = 1;
					}
				}
			}
		}
		else
		{
			for (b = startY; b < endY; b++)
			{
				for (a = startX; a < endX; a++)
				{
					iCollisionLayer[b][a] = 1;
				}
			}
		}
	}

	// Function to draw a tile, by number
	void drawBackgroundTile(int number, int x, int y)
	{
      // Set up the blitting rect
		SDL_Rect dest;
		dest.x = x;
		dest.y = y;

		if (number != 0)
		{
			switch(number)
			{
				case 1:
				SDL_BlitSurface(tileEarth[0], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				case 2:
				SDL_BlitSurface(tileEarth[1], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				case 3:
				SDL_BlitSurface(tileEarth[2], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				case 4:
				SDL_BlitSurface(tileEarth[3], NULL, surBackBuffer, &dest);
				drawBackgroundZone(2, x, y);
				break;

				case 5:
				SDL_BlitSurface(tileEarth[4], NULL, surBackBuffer, &dest);
				drawBackgroundZone(3, x, y);
				break;

				case 6:
				SDL_BlitSurface(tileEarth[5], NULL, surBackBuffer, &dest);
				drawBackgroundZone(13, x, y);
				break;

				case 7:
				SDL_BlitSurface(tileEarth[6], NULL, surBackBuffer, &dest);
				drawBackgroundZone(14, x, y);
				break;

				case 8:
				SDL_BlitSurface(tileEarth[7], NULL, surBackBuffer, &dest);
				drawBackgroundZone(8, x, y);
				break;

				case 9:
				SDL_BlitSurface(tileEarth[8], NULL, surBackBuffer, &dest);
				drawBackgroundZone(9, x, y);
				break;

				case 10:
				SDL_BlitSurface(tileEarth10, NULL, surBackBuffer, &dest);
				drawBackgroundZone(5, x, y);
				break;

				case 11:
				SDL_BlitSurface(tileGrass[0], NULL, surBackBuffer, &dest);
				drawBackgroundZone(10, x, y);
				break;

				case 12:
				SDL_BlitSurface(tileGrass[1], NULL, surBackBuffer, &dest);
				drawBackgroundZone(10, x, y);
				break;

				case 13:
				SDL_BlitSurface(tileGrass[2], NULL, surBackBuffer, &dest);
				drawBackgroundZone(6, x, y);
				break;

				case 14:
				SDL_BlitSurface(tileGrass[3], NULL, surBackBuffer, &dest);
				drawBackgroundZone(7, x, y);
				break;

				case 15:
				SDL_BlitSurface(tileGrass[4], NULL, surBackBuffer, &dest);
				drawBackgroundZone(11, x, y);
				break;

				case 16:
				SDL_BlitSurface(tileGrass[5], NULL, surBackBuffer, &dest);
				drawBackgroundZone(12, x, y);
				break;


				// Seabottom middle
				case 17:
				SDL_BlitSurface(tileSea[0], NULL, surBackBuffer, &dest);
				drawBackgroundZone(16, x, y);
				break;

				// Seabottom left corner
				case 18:
				SDL_BlitSurface(tileSea[1], NULL, surBackBuffer, &dest);
				drawBackgroundZone(17, x, y);
				break;

				// Seabottom right corner
				case 19:
				SDL_BlitSurface(tileSea[2], NULL, surBackBuffer, &dest);
				drawBackgroundZone(18, x, y);
				break;

				// Stone common
				case 20:
				SDL_BlitSurface(tile_stone[0], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				// Stone light
				case 21:
				SDL_BlitSurface(tile_stone[1], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				// Stone dark
				case 22:
				SDL_BlitSurface(tile_stone[2], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				// Stone window
				case 23:
				SDL_BlitSurface(tile_stone[3], NULL, surBackBuffer, &dest);
				drawBackgroundZone(1, x, y);
				break;

				// Special house
				case 26:
				SDL_BlitSurface(specialTiles[0], NULL, surBackBuffer, &dest);
				break;

				// Special statue
				case 27:
				SDL_BlitSurface(specialTiles[1], NULL, surBackBuffer, &dest);
				break;
			}
		}
	}

   // display the level backgrounds
	void displayLevelBackground()
	{
		SDL_Rect dest;
		dest.x = 0; dest.y = 0;
		SDL_BlitSurface(surBackBuffer, NULL, surMainScreen, &dest);

		// Scorepanel
		SDL_Rect dest2;
		dest2.x = 0; dest2.y = 400;
		SDL_BlitSurface(panelScore, NULL, surMainScreen, &dest2);
	}

	// Use the iAllBackgrounds to draw the level, and set up collision zones
	void drawLevelBackgrounds(bool initObjects)
	{
		// Go though the rows(b) and the cols(a) of the level, and draw out the tiles to the background buffer surface
      int a, b, x, y, obj; x = 0; y = 0;
		for (b = 0; b < 10; b++)
		{
			for (a = 0; a < 16; a++)
			{
				// Fetches the tile number from allbackgrounds
				// The room number is taken from iLevelMap
           	drawBackgroundTile(iAllBackgrounds[iLevel][(iLevelMap[iLevel][iMapOffsetY][iMapOffsetX])][b][a], x, y);

				// Villains
				if (initObjects)
				{
					obj = iAllObjects[iLevel][(iLevelMap[iLevel][iMapOffsetY][iMapOffsetX])][b][a];
					if (obj != 0)
					{
               	switch (obj)
						{
							case 2:
							taskListAddTo(2, x, y);
							break;

							case 3:
							// Rock with dripping water stuff
							taskListAddTo(3, x, y);
							break;

							case 4:
							// Rock with dripping water stuff
							taskListAddTo(202, x, y);
							break;

							case 5:
							// Water
							taskListAddTo(4, x, y);
							break;
							case 6:
							// Water
							taskListAddTo(5, x, y);
							break;
							case 7:
							// Water
							taskListAddTo(6, x, y);
							break;

							case 8:
							// Fairy
							taskListAddTo(7, x, y);
							break;

							case 9:
							// Apple bonus
							taskListAddTo(8, x, y);
							break;

							case 10:
							// Vertical platform
							taskListAddTo(9, x, y);
							break;

							case 11:
							// Dangerous bat
							taskListAddTo(10, x, y);
							break;

							case 12:
							// Life up! Extra life
							taskListAddTo(11, x, y);
							break;

							case 13:
							// Flying hat makes Squeek fly
							taskListAddTo(12, x, y);
							break;

							case 14:
							// Lightning bolt!
							taskListAddTo(13, x, y);
							break;

							case 15:
							// Troll
							taskListAddTo(14, x, y);
							break;
						}
					}
				}
				x += 40;
			}
			x = 0;
			y += 40;
		}
	}

	int drawSprite(SDL_Surface *image, int x, int y)
	{
		if (image == NULL)
		{
			return -1;
		}
		else
		{
			return 1;
		}
	}

	void drawScore()
	{
		int a; a = 0;

      char cScore[8];
		sprintf(cScore, "%08i", iScore);

		SDL_Rect scoreDest;
		scoreDest.x = 49;
		scoreDest.y = 444;

		for (a = 0; a < 8; a++)
		{
			if (((int)cScore[a]-48) > -1 & ((int)cScore[a]-48) < 10)
			{
				SDL_BlitSurface(abcNum[((int)cScore[a]-48)], NULL, surMainScreen, &scoreDest);
			}
			else
			{
				SDL_BlitSurface(abcNum[0], NULL, surMainScreen, &scoreDest);
			}
			scoreDest.x += 20;
		}
	}

	void drawLives()
	{
		SDL_Rect livesDest;
		livesDest.x = 60;
		livesDest.y = 407;
		SDL_BlitSurface(abcNum[iLives], NULL, surMainScreen, &livesDest);
	}

	void drawScreenBang()
	{
		// Do some cool thing here... 
	}


	void drawItems()
	{
		int a;
		int x[8];
		int y[8];
		SDL_Rect rect;

		x[0] = 250; y[0] = 430;
		x[1] = 280; y[1] = 430;
		x[2] = 310; y[2] = 430;
		x[3] = 340; y[3] = 430;
		x[4] = 250; y[4] = 450;
		x[5] = 280; y[5] = 450;
		x[6] = 310; y[6] = 450;
		x[7] = 340; y[7] = 450;

		for (a = 0; a < 8; a++)
		{
			rect.x = x[a]; rect.y = y[a];
			if (iHeroItems[a] != 0)
			{
				switch (iHeroItems[a])
				{
					case 1:
					// This is a fireball
					SDL_BlitSurface(item_fireball, NULL, surMainScreen, &rect);
					break;

					case 2:
					// This is a flying hat!
					SDL_BlitSurface(item_flyinghat, NULL, surMainScreen, &rect);
					break;

					case 3:
					// This is a lightning bolt
					SDL_BlitSurface(item_lightningsmall, NULL, surMainScreen, &rect);
					break;
				}
			}
			// Show the current item hand over current item
			if (a == iHeroCurrentItem)
			{
				SDL_BlitSurface(currentitem, NULL, surMainScreen, &rect);
			}
		}
	}

	int addItem(int n)
	{
		int a;
		for (a = 0; a < 8; a++)
		{
			if (iHeroItems[a] < 1)
			{
				iHeroItems[a] = n;
           	return 0;
			}
		}
	}

