

// Draw the background according to mode (0 or 1, off or on)
int drawBackground(int mode)
{
	int x;
	int y;
   SDL_Rect dest;
	dest.x = 0; dest.y = 0;

	for (y = 0; y < 10; y++)
	{
      for (x = 0; x < 16; x++)
		{
			if (iBackgroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] != 0)
			{
				dest.x = x*40;
				dest.y = y*40;
				SDL_BlitSurface(tiles[(iBackgroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x])-1], NULL, surBackBuffer, &dest);
			}
			if (iObjectData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] != 0)
			{
				dest.x = x*40;
				dest.y = y*40;
				SDL_BlitSurface(objects[(iObjectData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x])-1], NULL, surBackBuffer, &dest);
			}
			if (iForegroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] != 0)
			{
				dest.x = x*40;
				dest.y = y*40;
				SDL_BlitSurface(foregrounds[(iForegroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x])-1], NULL, surBackBuffer, &dest);
			}
		}
	}

	return true;
}


// Clear the draw surface
int clearDrawSurface()
{
	SDL_Rect rect;
	rect.x = 0;
	rect.y = 0;
	rect.w = 640;
	rect.h = 400;
	SDL_FillRect(surBackBuffer, &rect, SDL_MapRGB(surBackBuffer->format, 0, 0, 0));
}

int drawRectFrame()
{
	SDL_Rect dest;
	dest.x = iOffsetX;
	dest.y = iOffsetY;
   // Blit the current object
	if (iCurrentLayer == 0)
	{
		SDL_BlitSurface(tiles[iCurrentObject], NULL, surBackBuffer, &dest);
	}
	if (iCurrentLayer == 1)
	{
		SDL_BlitSurface(objects[iCurrentObject], NULL, surBackBuffer, &dest);
	}
	if (iCurrentLayer == 2)
	{
		SDL_BlitSurface(foregrounds[iCurrentObject], NULL, surBackBuffer, &dest);
	}
	// Blit the frame
	SDL_BlitSurface(editorRect, NULL, surBackBuffer, &dest);
}

int updateDisplay()
{
	SDL_Rect dest; dest.x = 0; dest.y = 0;
	SDL_Rect dest2; dest2.x = 0; dest2.y = 0; dest2.w = 640; dest2.h = 400;
	SDL_BlitSurface(surBackBuffer, &dest2, mainScreen, &dest);
}

int pasteObject()
{
	// get the right tile coordinates
	int x = iOffsetX/40;
	int y = iOffsetY/40;

	if (iCurrentLayer == 0)
	{
		iBackgroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] = iCurrentObject+1;
	}
	if (iCurrentLayer == 1)
	{
		iObjectData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] = iCurrentObject+1;
		if (iCurrentObject == 0)
		{
			iHeroStartX = x*40;
			iHeroStartY = y*40;
			iPlayerX = iMapX;
			iPlayerY = iMapY;

		}
	}
	if (iCurrentLayer == 2)
	{
		iForegroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][y][x] = iCurrentObject+1;
	}
}

// Save all level data!
int goSaveLevel()
{
	/*
		This is a bit comprehensive. Follow closely.

		There are some values that needs to be saved in a savegame. In the editor, some default values are generated,
		but they are left on the bottom of this file. The file is saved in aschii, and therefore it can become quite big! watch this:

		First we save the 160 different tile values for each room, being 100 rooms in each of the 24 levels
		So the first 384000 lines are therefore for the backgrounds. After this, we save out the same amount for
		the objects, and then for the foregrounds. This will in the end amount to 1152000 lines. After that we save
		out some smaller numbers ;)
	*/
	FILE *file;

	file = fopen("savegame.data","w+");

	int lev, room, row, col;

   // save all backgrounds

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					fprintf(file, "%d*", iBackgroundData[lev][room][row][col]);
				}
			}
		}
	}
	// save all objects

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					fprintf(file, "%d*", iObjectData[lev][room][row][col]);
				}
			}
		}
	}
	// save all foregrounds

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					fprintf(file, "%d*", iForegroundData[lev][room][row][col]);
				}
			}
		}
	}

	// Save hero position (x and y and startframe and gravity

	fprintf(file, "%d*%d*0*0*", iHeroStartX, iHeroStartY);

   // Save lives

	fprintf (file, "4*");

	// Save 8 items

	fprintf (file, "0*0*0*0*0*0*0*0*");

	// Save start score

	fprintf (file, "0*");

	// save map start

	fprintf (file, "%d*%d*", iPlayerX, iPlayerY);

	// Save start level

	fprintf (file, "0*");

   // Close the file

	fclose(file);
}

// Load a level
int goLoadLevel()
{
	/*
		This is a bit comprehensive. First we do a test
	*/
	FILE *file;
	int lev, room, row, col, a, b, c;
	char *wholeLevel = (char *)malloc(3000000);
	char *returnchar;
	char cTempNumber[3];

	a = 0;  // a seeks through the entire file

	// Open the file
	file = fopen("savegame.data","r");

	// load in the whole savegame into wholeLevel
	returnchar = fgets(wholeLevel, 3000000, file);

	// Close the file
	fclose(file);

	// Load it in (the backgrounds)
	c = 0;

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					// Go through the level data until * is met, which separates numbers
					b = 0;
					while (wholeLevel[a] != '*')
					{
						cTempNumber[b] = wholeLevel[a];
						a++;
						b++;
						// Go on and gather in the whole number from the data
					}
					a++;

					// Convert this two sifered number into an integer value
					iBackgroundData[lev][room][row][col] = atol(cTempNumber);
					// Reset the temp numbers
					cTempNumber[0] = 0; cTempNumber[1] = 0; cTempNumber[2] = 0;
				}
			}
		}
	}


	// Load it in (the objects)
	c = 0;

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					// Go through the level data until * is met, which separates numbers
					b = 0;
					while (wholeLevel[a] != '*')
					{
						cTempNumber[b] = wholeLevel[a];
						a++;
						b++;
						// Go on and gather in the whole number from the data
					}
					a++;

					// Convert this two sifered number into an integer value
					iObjectData[lev][room][row][col] = atol(cTempNumber);
					// Reset the temp numbers
					cTempNumber[0] = 0; cTempNumber[1] = 0; cTempNumber[2] = 0;
				}
			}
		}
	}

	// Load it in (the foregrounds)
	c = 0;

	for (lev = 0; lev < 24; lev++)
	{
		for (room = 0; room < 100; room++)
		{
			for (row = 0; row < 10; row++)
			{
				for (col = 0; col < 16; col++)
				{
					// Go through the level data until * is met, which separates numbers
					b = 0;
					while (wholeLevel[a] != '*')
					{
						cTempNumber[b] = wholeLevel[a];
						a++;
						b++;
						// Go on and gather in the whole number from the data
					}
					a++;

					// Convert this two sifered number into an integer value
					iForegroundData[lev][room][row][col] = atol(cTempNumber);
					// Reset the temp numbers
					cTempNumber[0] = 0; cTempNumber[1] = 0; cTempNumber[2] = 0;
				}
			}
		}
	}


   // Order all the rooms

	for (lev = 0; lev < 24; lev++)
	{
		a = 0;
		for (row = 0; row < 10; row++)
		{
			for (col = 0; col < 10; col++)
			{
				iLevelData[lev][row][col] = a;
				a++;
			}
   	}
	}	


	return 0;

}

