
	/*
		This is the sourcecode for the level editor of Squeek 2! This is the main
		module of this source code! (c) 2003 Hogne Titlestad - Wizard in the Moon developments
	*/

	// Various include files
	#include <iostream.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <math.h>
	#include <SDL/SDL.h>
	#include <SDL/SDL_image.h>
	// Level editor includes
	#include "levelEditorVariables.h"
	#include "levelEditorFunctions.h"

	int main(int argv, char *argc[])
	{
		if (SDL_Init(SDL_INIT_VIDEO) == -1)
		{
			cout << "Could not initialize the SDL video display.\nAborting...\n";
			exit(-1);
		}
		else
		{
			mainScreen = SDL_SetVideoMode(640, 480, 16, SDL_HWSURFACE|SDL_FULLSCREEN);
			// Load all graphics
			loadAllGraphics();

			int notquitEditor = true;
			while (notquitEditor)
			{
				while (SDL_PollEvent(&eventHandler)){}

				keyHandler = SDL_GetKeyState(NULL);

				// If the user wants to quit the editor
				if (keyHandler[SDLK_ESCAPE])
				{
					notquitEditor = false;
				}

				// Move the frame
            if (keyHandler[SDLK_DOWN] & iOffsetY < 360)
				{
					iOffsetY += 40;
				}
				if (keyHandler[SDLK_UP] & iOffsetY > 0)
				{
					iOffsetY -= 40;
				}
				if (keyHandler[SDLK_RIGHT] & iOffsetX < 600)
				{
					iOffsetX += 40;
				}
				if (keyHandler[SDLK_LEFT] & iOffsetX > 0)
				{
					iOffsetX -= 40;
				}

				// Paste in an object into the currect buffer
				if (keyHandler[SDLK_SPACE])
				{
					pasteObject();
				}

				// Move around in the rooms
				if (keyHandler[SDLK_KP6] & iMapX < 10)
				{
					iMapX += 1;
				}
				if (keyHandler[SDLK_KP4] & iMapX > 0)
				{
     				iMapX -= 1;
				}
				if (keyHandler[SDLK_KP8] & iMapY > 0)
				{
					iMapY -= 1;
				}
				if (keyHandler[SDLK_KP2] & iMapY < 10)
				{
     				iMapY += 1;
				}

				// Next/Prev object
				if (keyHandler[SDLK_KP_PLUS])
				{
					if (iCurrentLayer == 0)
					{
						if (iCurrentObject < 32)
						{
							iCurrentObject++;
						}
					}
					if (iCurrentLayer == 1)
					{
						if (iCurrentObject < 20)
						{
							iCurrentObject++;
						}
					}
					if (iCurrentLayer == 2)
					{
						if (iCurrentObject < 32)
						{
							iCurrentObject++;
						}
					}
				}
				if (keyHandler[SDLK_KP_MINUS])
				{
					if (iCurrentObject > 0)
					{
						iCurrentObject--;
					}
				}

            // Delete an object
				if (keyHandler[SDLK_DELETE])
				{
					if (iCurrentLayer == 0)
					{
						iBackgroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][(iOffsetY/40)][(iOffsetX/40)] = 0;
					}
					if (iCurrentLayer == 1)
					{
						iObjectData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][(iOffsetY/40)][(iOffsetX/40)] = 0;
					}
					if (iCurrentLayer == 2)
					{
						iForegroundData[iLevel][(iLevelData[iLevel][iMapY][iMapX])][(iOffsetY/40)][(iOffsetX/40)] = 0;
					}
				}

            // Change to the background layer
				if (keyHandler[SDLK_b])
				{
					iCurrentLayer = 0;
					iCurrentObject = 0;
				}

				// Change to the object layer
				if (keyHandler[SDLK_o])
				{
					iCurrentLayer = 1;
					iCurrentObject = 0;
				}

				// Change to the foreground layer
				if (keyHandler[SDLK_f])
				{
					iCurrentLayer = 2;
					iCurrentObject = 0;
				}

				// Save the level to a file
				if (keyHandler[SDLK_s])
				{
					goSaveLevel();
				}

				// Load the level from a file
				if (keyHandler[SDLK_l])
				{
					goLoadLevel();
				}

				clearDrawSurface(); // Clear the buffer screen
				drawBackground(1);
				drawRectFrame(); // Show the rect
				updateDisplay(); // Update the display
				SDL_Flip(mainScreen); // Show results

				// Wait for a key to be released
				while (eventHandler.type == SDL_KEYDOWN)
				{
					while (SDL_PollEvent(&eventHandler)){}
				}
			}
		}
		SDL_Quit();
		return 0;
	}
