
// Set up the sdl surfaces
SDL_Surface *mainScreen;
SDL_Surface *surBackBuffer;

SDL_Surface *tiles[32]; // Alltogether 32 tiles
SDL_Surface *objects[20]; // Alltogether 20 objects
SDL_Surface *foregrounds[32]; // Alltogether 32 foreground tiles
SDL_Surface *editorRect; // The frame around the draw surface

// Set up the event handlers
SDL_Event eventHandler;
Uint8 *keyHandler;

// Setup the level buffers
int iLevelData[24][10][10];
int iBackgroundData[24][100][10][16];
int iForegroundData[24][100][10][16];
int iObjectData[24][100][10][16];

// Setup the map offset coordinate integers

int iOffsetX = 0;
int iOffsetY = 0;

// Setup the room offset coordinate integers

int iMapX = 0;
int iMapY = 0;

// For the start hero
int iHeroStartX = 0;
int iHeroStartY = 0;
// For the start room offset
int iPlayerX; int iPlayerY;

// Setup the misc integers

int iCurrentObject = 0;
int iCurrentLayer = 0; // 0 is the background, 1 is the objects, 2 is the foreground
int iLevel = 0;

int loadAllGraphics()
{
	// Load the editor graphics

	editorRect = IMG_Load("graphics/editorRect.png");
	surBackBuffer = IMG_Load("graphics/backgroundBlack.bmp");

	// Load all the tiles

	tiles[0] = IMG_Load("graphics/tileEarth1.png");
	tiles[1] = IMG_Load("graphics/tileEarth2.png");
	tiles[2] = IMG_Load("graphics/tileEarth3.png");
	tiles[3] = IMG_Load("graphics/tileEarth4.png");
	tiles[4] = IMG_Load("graphics/tileEarth5.png");
	tiles[5] = IMG_Load("graphics/tileEarth6.png");
	tiles[6] = IMG_Load("graphics/tileEarth7.png");
	tiles[7] = IMG_Load("graphics/tileEarth8.png");
	tiles[8] = IMG_Load("graphics/tileEarth9.png");
	tiles[9] = IMG_Load("graphics/tileEarth10.png");

	/* The grass tiles: */
	tiles[10] = IMG_Load("graphics/tileGrass1.png");
	tiles[11] = IMG_Load("graphics/tileGrass2.png");
	tiles[12] = IMG_Load("graphics/tileGrass3.png");
	tiles[13] = IMG_Load("graphics/tileGrass4.png");
	tiles[14] = IMG_Load("graphics/tileGrass5.png");
	tiles[15] = IMG_Load("graphics/tileGrass6.png");

   // sea tiles

	tiles[16] = IMG_Load("graphics/tileSeaBottom1.png");
	tiles[17] = IMG_Load("graphics/tileSeaBottom2.png");
	tiles[18] = IMG_Load("graphics/tileSeaBottom3.png");

	// Stone (mur) tiles

	tiles[19] = IMG_Load("graphics/tile_stone.png");
	tiles[20] = IMG_Load("graphics/tile_stone_light.png");
	tiles[21] = IMG_Load("graphics/tile_stone_dark.png");
	tiles[22] = IMG_Load("graphics/tile_stone_window.png");

   // Special tiles
	tiles[25] = IMG_Load("graphics/house.png");
	tiles[26] = IMG_Load("graphics/statue.png");

	// Load all the object graphics

	objects[0] = IMG_Load("graphics/spriteHero1.png"); // squeek
	objects[1] = IMG_Load("graphics/objectGreeny1.png"); // green blob
	objects[2] = IMG_Load("graphics/water_dripper.png"); // dripping rock
	objects[3] = IMG_Load("graphics/obj_smoke.png"); // dripping rock
	objects[4] = IMG_Load("graphics/water01.png"); // Water surface
	objects[5] = IMG_Load("graphics/waterL01.png"); // Left water surface
	objects[6] = IMG_Load("graphics/waterR01.png"); // Right water surface
	objects[7] = IMG_Load("graphics/fairy_01.png"); // The fairy that gives advice
	objects[8] = IMG_Load("graphics/apple.png"); // The apple bonus object
	objects[9] = IMG_Load("graphics/platform_grass.png"); // The platform of grass that one can stand on
	objects[10] = IMG_Load("graphics/bat01.png"); // A dangerous bat
	objects[11] = IMG_Load("graphics/lifeup.png"); // One more life for Squeek
	objects[12] = IMG_Load("graphics/flying_hat.png"); // fly squeek fly!
	objects[13] = IMG_Load("graphics/lightning.png"); // Give Squeek the lightning biolt
	objects[14] = IMG_Load("graphics/troll01.png"); // Give Squeek the lightning biolt

	// Load all the foreground tiles

	foregrounds[0] = IMG_Load("graphics/fore_tree01.png");
	foregrounds[1] = IMG_Load("graphics/fore_tree02.png"); // Trees
	foregrounds[2] = IMG_Load("graphics/fore_tree03.png");

	foregrounds[3] = IMG_Load("graphics/fore_stone01.png"); // Stone

	foregrounds[4] = IMG_Load("graphics/water.png"); // Water
	foregrounds[5] = IMG_Load("graphics/waterL.png"); // Water
	foregrounds[6] = IMG_Load("graphics/waterR.png"); // Water
	foregrounds[7] = IMG_Load("graphics/waterBOT.png"); // Water
	foregrounds[8] = IMG_Load("graphics/waterLBOT.png"); // Water
	foregrounds[9] = IMG_Load("graphics/waterRBOT.png"); // Water

}


