// Various include files
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "glSDL.h"
#include "SDL/SDL_mixer.h"
// Core variables! Do not mess around unless you know what you are doing!
#include "standardVariables.h"

// Just include temporary functions... will be stripped later
//#include "tempFuncs.h"

// .h files are loaded after importance! Do not change the order!
#include "tasklistFunctions1.h"
#include "fileFunctions.h"
#include "graphicsLoaders.h"
#include "soundLoaders.h"
#include "graphicsFunctions.h"
#include "gameDialogs.h"
#include "gameObjects.h"
#include "tasklistFunctions2.h"


/*
	Done loading .h files ------------------------------------------------------->
*/

// Start main loop

int main(int argv, char *argc[])
{
   // Start SDL with INIT and open SDL window! (Also initializing joystick functions to be used later)

	if ((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_JOYSTICK)) == -1)
	{
		cout << "Oups! It seems SDL is playing tricky fishy guy here and\nthere. Should hit it mon'.\n";
		SDL_Quit();
	}
	else
	{
		surMainScreen = SDL_SetVideoMode(640,480,16,SDL_GLSDL|SDL_DOUBLEBUF|SDL_FULLSCREEN);
		cout << "Mix_OpenAudio: " << Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 1, 1024);
		loadSamples(); // Load all sound samples
		SDL_ShowCursor(0);
	}

	// Check for joystick
	if(SDL_NumJoysticks()>0)
	{
		// Open joystick
		theGamepad=SDL_JoystickOpen(0);
		if(!theGamepad)
		{
			// We can not use a gamepad
			//cout << "No joystick present...\n"; // For debugging
		}
		else
		{
			//cout << "We found a joystick!\n"; // For debugging
		}
	}



   // Generatr the main menu... eventually

	// Which is the main main loop

	int iExitSqueek = 0;

	while (iExitSqueek != 1)
	{

		SDL_Rect titleRect; titleRect.x = 0; titleRect.y = 0;
		SDL_Surface *titleScreen;
		titleScreen = IMG_Load("graphics/titlescreen_final.png");
		SDL_BlitSurface(titleScreen, NULL, surMainScreen, &titleRect);
		SDL_Flip(surMainScreen);

		Sint16 result;
		int keypressed = 0;

		while (keypressed != 1)
		{
			// Check joystick
			result = SDL_JoystickGetButton(theGamepad, 0);
			if (result)
			{
				keypressed = 1;
			}
			// Check keyboard
			while (SDL_PollEvent(&eEvent))
			{
			}
			uKeys = SDL_GetKeyState(NULL);
			if (uKeys[SDLK_SPACE])
			{
				keypressed = 1;
			}
			if (uKeys[SDLK_ESCAPE])
			{
          	iExitSqueek = 1;
				keypressed = 1;
			}
		}
		if (iExitSqueek == 1)
		{
			break; // Break off and quit
		}

		// Load in choosen file

		/*char thisChar[32] = "Hallo din lille pinglemann..";
		iReturnVar = fileLoadLevel(thisChar);*/
		goLoadLevel();

		// Clear item list

		int a;
		for (a = 0; a < 8; a++)
		{
			iHeroItems[a] = 0;
		}

		fancyFadeToBlack();
		SDL_FreeSurface(titleScreen);
		keypressed = 0;

		// Set some first time variables
		iQuitgame = 0;
		iChangeLevel = 1;
		SqueekStory = 0; // make sure the story is reset
		SqueekFairy = 0; // make sure the fairy is reset


		while (iQuitgame == 0)
		{

			// Draw background and foreground
			if (iChangeLevel == 1)
			{
				iChangeLevel = 0;
				loadGraphics();
			}

			taskListFlush(); // Flush the tasklist to ready for new objects


			// Generate Squeek as the first task/object
			fTasklist[0][0] = 1;
			fTasklist[0][1] = (float)iEnterX;
			fTasklist[0][2] = (float)iEnterY;

			// Set the escape variable to 0
			iEscape = 0;

			// Draw background to the back buffer
			clearBuffers(); // Clear all tile and object buffers
			drawLevelBackgrounds(1);


			// Game loop:
			// Each time we exit this loop, the level is redrawn from the new variables, like if
			// iLevel has changed, or iMapOffsetX or Y...
			while (iEscape == 0)
			{
				iTimeStartLoop = SDL_GetTicks();
				iTimeCurrent = iTimeStartLoop;

				// Grab events
				while (SDL_PollEvent(&eEvent))
				{
				}
				uKeys = SDL_GetKeyState(NULL);
				if (uKeys[SDLK_ESCAPE])
				{
					iQuitgame = 1;
					break;
				}

				// Show level with all the objects!

				displayLevelBackground();

				// Draw score numbers
				drawScore();
				// Draw the items
				drawItems();
				// Draw the current score
				drawLives();

				// Check for objects here
				taskListCheck();

				// Draw foreground
				drawForeground();

				// Wait till it has at least gone 40 ticks
				while (iTimeCurrent < iTimeStartLoop+5)
				{
					iTimeCurrent = SDL_GetTicks();
				}

				SDL_Flip(surMainScreen);

				// We cannot live without lives :)
				if (iLives == -1)
				{
					iEscape = 1;
				}
			}

			// Check if we are out of lives
			if (iLives == -1)
			{
				iQuitgame = 1;
			}


			iHeroX = (int)fTasklist[0][1]; // Remember current hero position
			iHeroY = (int)fTasklist[0][2]; // Remember current hero position
		}
	}

	// Quit SDL

	if(SDL_JoystickOpened(0))
	{
		// Close an opened joystick
		SDL_JoystickClose(theGamepad);
	}

	Mix_CloseAudio();
	SDL_Quit();
	// Free all surfaces
	freeAllSurfaces();

	// We are gone, ended, and the user has quit!! Perhaps this place should clean up unused variables and so forth???
	return 0;
}



