#!/path-to-php-executable/php-executable -q
<?
/* stars.c		by Nathan Strong
 *
 * based on stars.bas, written by a friend of mine who goes by 'beek' in
 * the world of the internet :-) There is no copyright, no restrictions,
 * and most definitely no warranty on this software. I won't guarantee
 * that it will compile, or that it will not cause damage to your system
 * or your hardware. It's not like this is incredibly complicated code,
 * anyway, so it's your own fault for not checking the code first!
 *
 * You can do anything you want with this code. Use it in your next demo!
 * print it out and use it as wallpaper! Write me flamemail telling me how
 * much I suck at programming (my e-mail is gblues@gstis.net)!
 *
 * The only thing I ask is for credit, even if it's a "This portion
 * based on stars.c by Nathan Strong" buried deep in the source code
 * that nobody will ever see. I was nice enough to credit my friend beek
 * in the source, you can do the same for me :)
 *
 * You're still reading this? What's the matter with you? You must be
 * a lawyer or something :)
 */

/* Responsible for bad reformatting : <andreas.beck@ggi-project.org> */

set_time_limit(0);

if (!extension_loaded('sdl')) {
	if (!dl( (strstr(PHP_OS, 'WIN') ? 'php_sdl.dll' : 'sdl.so'))) {
		exit;
	}
}

$video = array();
$colors = array();
$xoff = 0;
$yoff = 0;
$angle = 0.0;
$frame = 0;
$stars = array();
$starsr = array();
$old = array();

$fps = 0.0;
$i = 0;
$x = 0;
$y = 0;
$oldx = 0;
$oldy = 0;
$color = 0;

if (!isset($argv)) $argv = $_SERVER['argv'];
if ( $argv[1] && (strcmp($argv[1], "-hw") == 0) ) {
	InitGraphics(SDL_HWSURFACE);
} else {
	InitGraphics(SDL_SWSURFACE);
}

InitStars();

$st = time(NULL);

do {
	if ( SDL_MUSTLOCK($video) ) {
		if ( SDL_LockSurface($video) < 0 )
			continue;
	}
	
	unset($pixels);
	$pixels = array();
	for ($i = 0; $i < 100; $i++)
	{
		$old[$i][0] = $starsr[$i][0];
		$old[$i][1] = $starsr[$i][1];
		$old[$i][2] = $starsr[$i][2];

		$starsr[$i][0] = $stars[$i][0];
		$starsr[$i][1] = $stars[$i][1];
		$starsr[$i][2] = $stars[$i][2];

		Transform(&$starsr[$i][1], &$starsr[$i][2]);
		Transform(&$starsr[$i][0], &$starsr[$i][2]);
		Transform(&$starsr[$i][0], &$starsr[$i][1]);

		$oldx = (int) floor(((256*$old[$i][0])/($old[$i][2]-1024))+$xoff);
		$oldy = (int) floor(((256*$old[$i][1])/($old[$i][2]-1024))+$yoff);

		$x = (int) floor(((256*$starsr[$i][0])/($starsr[$i][2]-1024))+$xoff);
		$y = (int) floor(((256*$starsr[$i][1])/($starsr[$i][2]-1024))+$yoff);
	
		$color = floor(($starsr[$i][2] + 721) / 5.5);
		
		$pixels[] = array('x' => $oldx, 'y' => $oldy, 'pixel' => $colors[0]);
		$pixels[] = array('x' => $x, 'y' => $y, 'pixel' => $colors[$color]);
		
	}
	
	SDL_putpixels($video, $pixels);
	
	if ( SDL_MUSTLOCK($video) ) {
		SDL_UnlockSurface($video);
	}
	SDL_UpdateRect($video, 0, 0, 0, 0);
	$frames++;
	$angle += 0.5;
} while( SDL_PollEvent(NULL) == 0);

if ((time(NULL) - $st) != 0) {
	$fps = (double)$frames / (time(NULL) - $st);
}

printf("%2.2f frames per second\n", $fps);
printf("beek / lightspeed\n\nPorted to GGI by Nathan Strong\n");
printf("Ported to SDL by Sam Lantinga\n");
printf("Ported to PHP+SDL by Brian Wang\n");

function Transform(&$ta, &$tb)
{
	global $angle;

	$y = 0.0;
	$z = 0.0;
	$y = (cos(($angle / 20)) * $ta) - (sin(($angle / 20)) * $tb);
	$z = (sin(($angle / 20)) * $ta) + (cos(($angle / 20)) * $tb);
	$ta = (int) floor($y);
	$tb = (int) floor($z);
}

function InitStars() 
{
	global $stars;
	
	srand(time(NULL));
	for ($i = 0; $i < 100; $i++)
	{
		$stars[$i][0] = ((rand() % 320)+1 - 160) * 3;
		$stars[$i][1] = ((rand() % 320)+1 - 160) * 3;
		$stars[$i][2] = ((rand() % 128)+1 - 64) * 5;
	}
}

function InitGraphics($video_flags) 
{
	global $video, $colors, $xoff, $yoff;

	if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		exit;
	}

	// $video = SDL_SetVideoMode(640, 480, 0, $video_flags|SDL_FULLSCREEN);
	$video = SDL_SetVideoMode(640, 480, 0, $video_flags);
	if(!$video) {
		exit;
	}
	
	printf("Set %dx%dx%d video mode\n", $video['w'], $video['h'], $video['format']['BitsPerPixel']);
	$xoff = $video['w']/2;
	$yoff = $video['h']/2;

	/* Assuming 8-bit palette */
	if ( $video['format']['palette'] ) {
		for ($i = 0; $i < 256; $i++) {
			$clut[$i]["r"] = $i;
			$clut[$i]["g"] = $i;
			$clut[$i]["b"] = $i;
		}
		SDL_SetColors($video, $clut, 0, 256);
	}
	for ($i = 0; $i < 256; $i++) {
		$colors[$i] = SDL_MapRGB($video['format'], $i, $i, $i);
	}

	/* We ignore all but keyboard events */
	for ( $i = 0; $i<SDL_NUMEVENTS; ++$i ) {
		if ( ($i != SDL_KEYDOWN) && ($i != SDL_QUIT) ) {
			SDL_EventState($i, SDL_IGNORE);
		}
	}
}

?>
