
	// These variable can be overwritten by the game loader

	int 		iAllBackgrounds[24][100][10][16]; // The levels, rooms, and columns, rows for the tiles of the backgrounds
	int 		iAllForegrounds[24][100][10][16]; // The levels, rooms, columns, rows for the foregrounds (can be animated!?)
	int 		iAllObjects[24][100][10][16]; // The levels, rooms, columns, rows for the objects (which have AI)
	int		iLevelMap[24][10][10]; // The levels, and y, x as offsets in the maps -- points to the three arrays above (orders them)
	int 		iCollisionLayer[400][640]; // The layer shows where objects collide with the background
	int 		iScore; // The score of the hero
	int 		iLives; // The lives
	int 		iLevel; // Current level
	int		iMapOffsetX; // current x offset in the iLevelMap[24][y][x]
	int		iMapOffsetY; // current y offset in the iLevelMap[24][y][x]
	int 		iHeroX; // The current X coordinate
	int 		iHeroY; // The current Y coordinate
	int		iHeroFrame; // The current frame image
	int		iHeroDirection; // The direction squeek is facing
	int		iHeroJump; // Can squeek jump now?
	int 		iHeroItems[8]; // squeek's inventory [number from 0 to 7] which holds another number pointing to the item
	int		iHeroCurrentItem; // which is the current item? (0 to 7)
	int		iWeaponLevel = 12; // The level grade will be upgraded, but is 12 in the beginning
	char		cPlayername[32]; // The player name, up to 32 characters

	// These variables are standard, and are used by the game

	int		iEscape; // this is the variable that tells the main game loop to exit if it is 1 - used for room change and others
	float		fGravity; // what is the gravity? will pull squeek down, or become minus when he jumps...
	char		cLevelFileName[32]; // The filename of the level that is used
	float 	fTasklist[99][32]; // IMPORTANT: everything happens from this array!
	int		igameMode; // Gamemode is boolean really... 0 if for normal storyline mode, and 1 is for practise mode (custom savegames)
	int		iReturnVar; // Every int function can return a value to this
	float		fReturnVar; // Every float function can ....
	char		cReturnVar; // Every char...
	int		iQuitgame; // If the game is to be quittewd
	int		iChangeLevel; // If we are changing level, in which case new graphics are to be loaded!
	int		iEnterX; // The x coordinate where Squeek entered the room
	int		iEnterY; // The y coordinate where Squeek entered the room
	float		fEnterGravity; // The gravity value where Squeek entered the room

   // Time related

	int iTimeStartLoop; // The time when the loop starts in sdl ticks
	int iTimeCurrent; // The current

	// Some other variables for graphics -- important

	/*
	 	The four surfaces under are used to display all graphics:
			First, the mainscreen is opened...
			In the game container loop, where we calculate lives, room... the whole level is drawn to the backsurface and the foreground to foreground surface
			In the game loop time, the objects are drawn to the object surface
			Then we draw the background, the objects and then the foreground to the mainscreen
	*/
	SDL_Surface *surMainScreen; // The screen that is opened
	SDL_Surface *surBackBuffer; // The buffer for the background tiles
	SDL_Surface *surObjeBuffer; // The buffer for all the objects (is cleared all the time);
	SDL_Surface *surForeBuffer; // The buffer for the foreground
	SDL_Surface *panelScore;	// The score buffer

	// Some other surfaces for background tiles

	SDL_Surface *tileEarth[9];
	SDL_Surface *tileEarth10;
	SDL_Surface *tileGrass[9];
	SDL_Surface *tileSea[9];
	SDL_Surface *tile_stone[4];
	SDL_Surface *specialTiles[10];

	// Objects:

	SDL_Surface *hero[10];
	SDL_Surface *objectBall;
	SDL_Surface *objectGreeny[4];
	SDL_Surface *weaponFireball[3];
	SDL_Surface *objectTearDrop;
	SDL_Surface *objectDrippingRock;
	SDL_Surface *obj_water[4];
	SDL_Surface *obj_Lwater[5];
	SDL_Surface *obj_Rwater[6];
	SDL_Surface *objectFairy[6];
	SDL_Surface *obj_apple;
	SDL_Surface *obj_platform;
	SDL_Surface *obj_bat[8]; // Dangerous bat
	SDL_Surface *obj_extralife; // Extra life
	SDL_Surface *obj_flyinghat; // Makes Squeek fly with a flying hat
	SDL_Surface *objectTroll[3]; // The evil troll

   // Items:
	SDL_Surface *item_fireball;
	SDL_Surface *item_flyinghat;
	SDL_Surface *item_flyhat[6];
	SDL_Surface *item_lightning;
	SDL_Surface *item_lightningsmall;
	SDL_Surface *weaponLightning;

	SDL_Surface *currentitem;

	// Foregrounds

	SDL_Surface *foregrounds[32];

   // Particles:

	SDL_Surface *objectParticleSmoke[9];
	SDL_Surface *objectParticleSmoke2[9];
	SDL_Surface *objectParticleExplosion[5];

   // Numbers and ABC

	SDL_Surface *abcNum[10];
	SDL_Surface *abcLetters[30];


	// Event variables

	SDL_Event eEvent;
	Uint8* uKeys;
	SDL_Joystick *theGamepad;

	// Rect variable (reusable!)

	SDL_Rect rectDest;

	// Story variables

	int SqueekStory = 0;
	int SqueekFairy = 0;

	int iTrollHits = 0;

	void resetVariables()
	{
		// Clear skills etc

		resetVariables();
		iWeaponLevel = 12;
		iHeroDirection = 0;
		iHeroFrame = 0;


		// The current item as the game starts is the first one (0 to 7 remember?)
		iHeroCurrentItem = 0;

		// Troll
		iTrollHits = 0;

		// Story
		SqueekStory = 0;
		SqueekFairy = 0;

		// Other
		iWeaponLevel = 12; // The level grade will be upgraded, but is 12 in the beginning
	}
